var defaultEnvironment, readFileSync;
defaultEnvironment = require('./environment').defaultEnvironment;
readFileSync = require('fs').readFileSync;
/**
 *  Register an extension to use with NodeJS, so that require-ing a
 *  template transforms it automatically into a template.
 *  @param ext: the extension
 *  @param filter: a callback (str) -> that transforms the source before
 *      giving it to JinJS.
 */
function registerExtension(ext, filter){
  filter == null && (filter = function(str){
    return str;
  });
  return require.extensions[ext] = function(module, filename){
    var javascript_file;
    javascript_file = defaultEnvironment.getTemplateSourceFromString(filter(readFileSync(filename, 'utf-8')));
    return module._compile(javascript_file, filename);
  };
}
exports.registerExtension = registerExtension;